FactoryGirl.define do
  factory :academic_program do
    sequence(:full_name) {|n| "Anthropology, B.A.-#{n}"}
    discipline "Anthropology"
    level { AcademicProgram::LEVELS.sample }
    mission "equips people to do stuff"
    degree { AcademicProgram::DEGREES.sample }
    outcomes_intro "<p>Upon completion of the Master of Arts in Christian Ministry and Leadership, students will be able to:</p>"
    school

    trait :with_attachment do
      association :attachable, factory: :attachments
    end

    trait :bachelor do
      level { :bachelor }
      degree { ["B.A.", "B.S.", "B.M.", "B.F.A."].sample }
    end

    trait :graduate do
      level { :graduate }
      degree { ["M.A.", "M.B.A.", "M.Div.", "Th.M."].sample }
    end

    trait :learning_outcome do
      after(:build) do |academic_program|
        FactoryGirl.create :learning_outcome, academic_program: academic_program
      end
    end
  end
end
