FactoryGirl.define do
  factory :department do
    sequence(:title) { |n| Faker::Commerce.department+"#{n}" }
    location { Faker::Address.street_name }
    location_details "over the hills and through the woods"
    description { "<p>We #{Faker::Company.bs}.</p>" }
    email { Faker::Internet.email }
    phone { Faker::PhoneNumber.extension}
    fax { Faker::PhoneNumber.extension}

    trait :with_social_media do
      # make sure you persist the Department before trying to build the embedded document
      social_medium
    end

    trait :with_department_contact do
      department_contact
    end

    trait :with_membership do
      memberships { [FactoryGirl.build(:membership)] }
    end

    trait :with_unpublished_membership do
      memberships { [FactoryGirl.build(:membership, :unpublished)] }
    end
  end
end
