FactoryGirl.define do
  factory :event do
    transient do
      # in order to override default Faker::Time, add start_date and (optionally) end_date attributes to event
      start_time { start_date || Faker::Time.between(DateTime.now - 5, DateTime.now + 90) }
      end_time { end_date || start_time + 2.hours }
    end

    site
    sequence(:title) {|n| [Faker::Lorem.words(5), n].join(' ').titleize }
    sequence(:slug) {|n| [Faker::Internet.slug(nil, '-'), n].join('-') }
    description { Faker::Lorem.paragraph }
    teaser { Faker::Lorem.sentence }
    image { File.open(BuwebContentModels.root.join('spec/fixtures/upload.png')) }

    after(:build) do |event, evaluator|
      build :event_occurrence, event: event, start_time: evaluator.start_time, end_time: evaluator.end_time
    end
  end
end
